Subject: Re: bug#33847: 27.0.50; emacsclient does not find server socket

From: Eli Zaretskii <[email-masked]>
Date: Sun, 25 Jul 2021 09:32:32 +0300

> Cc: [email-masked], [email-masked], [email-masked], [email-masked]
> From: Paul Eggert <[email-masked]>
> Date: Sat, 24 Jul 2021 16:31:21 -0700
> 
> In looking into this, I noticed that our current approach has another 
> problem, because admin/merge-gnulib avoids Gnulib's malloc-posix module 
> so that the Emacs build procedure need not worry about Gnulib's malloc 
> interposition on MS-Windows. However, Gnulib relies on the POSIX malloc 
> spec in its own use of malloc, so malloc-posix should be present in 
> Emacs; this is for the benefit of some platforms that are neither GNU 
> nor MS-Windows.
> 
> What we should do is (A) have the Emacs tarball contain whatever Gnulib 
> memory-allocation modules Gnulib needs, (B) arrange for Gnulib's 
> memory-allocation modules to be inactive on MS-Windows, and (C) arrange 
> for Emacs's private implementation of malloc/realloc/free to be 
> GNU-compatible.

Right.

> Proposed patches attached to do all this. Patch 4/4 is the one needing 
> most scrutiny, since it involves MS-Windows which I don't use.

Thanks, will review that shortly.

> > Can you tell which Gnulib modules are affected by the new
> > "--disable-year2038" option?
> 
> No modules are affected by the --disable-year2038 option on MS-Windows.
> 
> The --disable-year2038 option has an effect only on 32-bit GNU/Linux x86 
> and ARM (glibc 2.34 and later). On these platforms, the option affects a 
> good many Gnulib modules as well as Emacs source code directly. This is 
> because the option affects anything that gets or sets a timestamp from 
> the OS. 'stat' syscalls, for example.
> 
> As I understand it, MS-Windows switched to 64-bit time_t back in 2005 
> (even on 32-bit platforms), and nowadays you have to explicitly request 
> 32-bit time_t (does anybody do that when building Emacs? I hope not). 

This is only mostly correct.  It is true that MS-Windows switched to
64-bit time_t as the preferred method some time ago even on 32-bit
versions of Windows.  But to build an Emacs that will run on versions
of Windows before the switch, which means all versions before XP, you
_must_ compile with 32-bit time_t, because those older platforms
simply don't have the 64-bit time_t variants of relevant libc
functions in their C runtime DLL, so Emacs using 64-bit time_t will
refuse to start on them.  And since we still try to support those
older systems, the 32-bit build of Emacs on Windows does use 32-bit
time_t -- if it is built with mingw.org's MinGW (where time_t is a
32-bit type by default, so no need for any specific requests), because
MinGW64 tossed the support for those older versions long ago, and thus
even its 32-bit versions cannot be used to build an Emacs which will
run on anything before Vista.

> The --disable-year2038 option does not have any effect on MS-Windows, 
> because nobody has bothered to add support for that option on that 
> platform and I expect and hope that nobody ever will.

So therefore my question seems to be even more important than I
thought, and I'm still asking which Gnulib modules are affected by
this, because I'd need to audit them carefully to see whether the
32-bit MS-Windows build with mingw.org's MinGW could be affected.  Can
you show the list of those modules (out of those which Emacs imports),
so I could take a look at them?

> Any Emacs executables built with the --disable-year2038 option on 
> GNU/Linux x86 or ARM will of course stop working after 2038, so it's not 
> an option I recommend.

That's 17 years in the future, so it will be a real concern in about
15 years, I'd say.  let's talk then ;-)

Thanks.